//
//  NekoView.h
//  Neko Type-R

/*
Copyright (c) 2005 Vince Tagle <vtagle@newsguy.com>

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated 
documentation files (the "Software"), to deal in the Software without restriction, including without limitation 
the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and 
to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of 
the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO 
THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE 
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, 
TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE 
SOFTWARE.
*/

#import <Cocoa/Cocoa.h>
#include "NekoConstants.h"


@class NekoController; 
@class NekoTyper; 
@class NekoTypingTeam; 
@class WordDispenser; 

enum
{
	kStartPhaseOnMark, 
	kStartPhaseGetSet, 
	kStartPhaseGo, 
	kStartPhaseMax
};

@interface NekoView : NSView 
{
	NekoController*		controller; 
	NSMutableArray*		nekoTypers; 
	NSMutableArray*		catNames;
	NSMutableString*	charactersTyped;
	NekoTypingTeam*		playerTeam; 
	NekoTypingTeam*		computerTeam; 
	WordDispenser*		words; 
	
	UInt32		raceNumber; 
	SInt32		startPhase; 
	UInt32		nextStartPhaseAtTime; 
	BOOL		gameOver; 
	NSTimer*	nekoUpdater; 
	
	NSImage*	introScreenImage; 
	NSImage*	startPhaseImages[kStartPhaseMax]; 
}

- (NSArray *)processTextFile: (NSString *)textFile;
- (void)startNextRace: (BOOL)newGame; 
- (void)handleUpdateNekoTeams; 
- (void)playerWonRaceSheetDidEnd: (NSWindow *)sheet returnCode: (int)returnCode contextInfo: (void *)contextInfo;
- (void)updateStartPhaseDisplay; 
- (void)increaseRaceDifficulty; 
- (void)updateWordsPerMinute: (UInt32)wpm ofTeam: (NekoTypingTeam *)team; 
- (void)powerdownEffect: (UInt32)type fromTeam: (NekoTypingTeam *)team; 
- (BOOL)gameOver; 
- (void)endCurrentRace; 

@end
